package com.ruoyi.bst.fault.mapper;

import java.util.List;

import com.ruoyi.bst.order.domain.OrderQuery;
import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.fault.domain.Fault;
import com.ruoyi.bst.fault.domain.FaultQuery;
import com.ruoyi.bst.fault.domain.FaultVO;

/**
 * 故障Mapper接口
 *
 * @author ruoyi
 * @date 2025-03-26
 */
public interface FaultMapper
{
    /**
     * 查询故障
     *
     * @param id 故障主键
     * @return 故障
     */
    FaultVO selectFaultById(Long id);

    /**
     * 查询故障列表
     *
     * @param query 故障
     * @return 故障集合
     */
    List<FaultVO> selectFaultList(@Param("query")FaultQuery query);

    /**
     * 新增故障
     *
     * @param fault 故障
     * @return 结果
     */
    int insertFault(Fault fault);

    /**
     * 批量新增故障
     */
    int batchInsert(@Param("list") List<? extends Fault> list);

    /**
     * 批量修改故障
     */
    int batchUpdate(@Param("list") List<? extends Fault> list);

    /**
     * 修改故障
     *
     * @param fault 故障
     * @return 结果
     */
    public int updateFault(@Param("data") Fault fault);

    /**
     * 删除故障
     *
     * @param id 故障主键
     * @return 结果
     */
    int deleteFaultById(Long id);

    /**
     * 批量删除故障
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteFaultByIds(Long[] ids);

    FaultVO selectFaultByUserId(Long id);

    /**
     * 根据条件查询故障数量
     * @param query
     * @return
     */
    int selectCount(@Param("query") FaultQuery query);

    /**
     * 根据条件查询故障ID
     * @param query
     * @return
     */
    List<Long> selectIdByQuery(@Param("query") FaultQuery query);

    int updateByQuery(@Param("data") Fault data,@Param("query") FaultQuery query);
}
